/* Script generated by Pawn Studio */

#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <fakemeta>
#include <hamsandwich>
#include <xs>

#define PLUGIN	"iSeeLegs"
#define AUTHOR	"DarkGL"
#define VERSION	"1.0"

new userModel[ 33 ];

new const szClassName[ 256 ] = "iSeeLegs";

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	RegisterHam( Ham_Spawn , "player", "fwSpawned" , 1 );
	RegisterHam( Ham_Killed , "player", "fwKilled" , 1 );
	
	register_forward( FM_AddToFullPack , "fwAddToFullPack" , 1 );
}

public fwSpawned( id ){
	if( !is_user_alive( id ) ){
		return HAM_IGNORED;
	}
	
	if( pev_valid( userModel[ id ] ) ){
		remove_entity( userModel[ id ] );
	}
	
	userModel[ id ] = 0;
	
	new szModel[ 256 ];
	
	pev( id , pev_model , szModel , charsmax( szModel ) );
	
	new iEnt = engfunc( EngFunc_CreateNamedEntity , engfunc( EngFunc_AllocString , "info_target" ) );
	
	if( !pev_valid( iEnt ) ){
		return 0;
	}
	
	new Float: fOrigin[ 3 ],
		Float: fAngles[ 3 ],
		Float: fMins[ 3 ],
		Float: fMaxs[ 3 ];
	
	pev( id , pev_angles , fAngles );
	pev( id , pev_origin , fOrigin );
	
	pev( id , pev_mins , fMins );
	pev( id , pev_maxs , fMaxs );
	
	engfunc( EngFunc_SetOrigin , iEnt , fOrigin );
	engfunc( EngFunc_SetModel , iEnt , szModel );
	engfunc( EngFunc_SetSize , iEnt , fMins , fMaxs );
	
	set_pev( iEnt , pev_angles , fAngles );
	set_pev( iEnt , pev_solid , SOLID_TRIGGER );
	
	set_pev( iEnt , pev_owner , id );
	
	set_pev( iEnt , pev_rendermode , kRenderTransAlpha );
	set_pev( iEnt , pev_renderamt , 255.0 );
	
	set_pev( iEnt , pev_classname , szClassName );
	
	set_pev( iEnt , pev_framerate , 1.0 );
	
	set_pev( iEnt , pev_gaitsequence , 1 );
	
	userModel[ id ] = iEnt;
	
	return HAM_IGNORED;
}

public fwAddToFullPack(es_state, e, ENT, HOST, hostflags, player, set){
	if( player )
		return FMRES_IGNORED;
	
	if( !is_user_alive( HOST ) ){
		return FMRES_IGNORED;
	}
	
	if( !pev_valid( ENT ) ){
		return FMRES_IGNORED;
	}
	
	new szCurrentClass[ 256 ];
	
	pev( ENT , pev_classname , szCurrentClass , charsmax( szCurrentClass ) );
	
	if( !equal( szClassName , szCurrentClass ) ){
		return FMRES_IGNORED;
	}
	
	if( pev( ENT , pev_owner ) == HOST ){
		return FMRES_IGNORED;
	}
	
	set_es( es_state , ES_RenderMode , kRenderTransAlpha );
	set_es( es_state , ES_RenderAmt , 0.0 );
	
	return FMRES_IGNORED;
}

public fwKilled( id ){
	if( pev_valid( userModel[ id ] ) ){
		remove_entity( userModel[ id ] );
	}
	
	userModel[ id ] = 0;
}

public client_PreThink( id ){
	if( !is_user_alive( id ) ){
		return PLUGIN_CONTINUE;
	}
	
	new Float: fOrigin[ 3 ],
		Float: fAngles[ 3 ],
		Float: fVector[ 3 ],
		Float: fAnglesV[ 3 ];
	
	new	Float: fVelocity[ 3 ];
		
	new Float: playerFrame,
		Float: playerAnimTime;
	
	new Float: fSpeed = 0.00;
	
	pev( id , pev_angles , fAngles );
	pev( id , pev_origin , fOrigin );
	pev( id , pev_v_angle , fAnglesV );
	pev( id , pev_frame , 	playerFrame );
	pev( id , pev_animtime , playerAnimTime );
	pev( id , pev_velocity , fVelocity );
	
	angle_vector( fAnglesV , ANGLEVECTOR_FORWARD , fVector );
	
	fVector[ 2 ] = 0.0;
	
	xs_vec_neg( fVector , fVector );
	xs_vec_normalize( fVector , fVector );
	xs_vec_mul_scalar( fVector , 18.0 , fVector );
	
	xs_vec_add( fVector , fOrigin , fOrigin );
	
	set_pev( userModel[ id ] , pev_origin , fOrigin );
	set_pev( userModel[ id ] , pev_angles , fAngles );
	
	set_pev( userModel[ id ] , pev_sequence ,3 );
	
	fSpeed = vector_length( fVelocity );
	
	if( fSpeed == 0.00 ){
		set_pev( userModel[ id ] , pev_framerate , 0.00 );
	}
	else{
		set_pev( userModel[ id ] , pev_framerate , fSpeed / 125.0 );
	}
	
	return PLUGIN_CONTINUE;
}

public client_connect( id ){
	userModel[ id ] = 0;
}

public client_disconnect( id ){
	if( pev_valid( userModel[ id ] ) ){
		remove_entity( userModel[ id ] );
	}
	
	userModel[ id ] = 0;
}